searchNodes=[{"doc":"Uderzo Elixir-&gt;C bindings in Clixir. Note that for demo purposes, this is a hodgepodge of various modules - NanoVG, GLFW, utility methods, demo methods; there's nothing however that precludes a clean separation. Yet ;-)","ref":"Uderzo.Bindings.html","title":"Uderzo.Bindings","type":"module"},{"doc":"Create a window using the GLFW library. The window will have the indicated height and width.Upon completion, one of two results will be sent to pid:{:error, error_message} when an error occurs{:glfw_create_window_result, window_handle} on success. The window_handle must be stored and passed into later drawing operations.On the RaspberryPi 3 VideoCore target, this function still needs to be called even though an actual window is not created.","ref":"Uderzo.Bindings.html#glfw_create_window/4","title":"Uderzo.Bindings.glfw_create_window/4","type":"function"},{"doc":"Destroy the indicated window. window is a window handle returned from glfw_create_window/4.","ref":"Uderzo.Bindings.html#glfw_destroy_window/1","title":"Uderzo.Bindings.glfw_destroy_window/1","type":"function"},{"doc":"Complete a frame. Similarly to uderzo_start_frame/2, this does some housekeeping and eventually a buffer swap to display the frame. When complete, this sends the atom :uderzo_end_frame_done to pid. This can be used to synchronize on complete frames.On the Raspberry Pi 3 this function will also copy the contents of the frame to the secondary framebuffer, /dev/fb1, if available. This secondary framebuffer usually corresponds with a correctly configured HAT display (see the Nerves demo in the Uderzo source repository for an example).","ref":"Uderzo.Bindings.html#uderzo_end_frame/2","title":"Uderzo.Bindings.uderzo_end_frame/2","type":"function"},{"doc":"Initialize Uderzo. Calling this is mandatory.Upon completion, pid will receive :uderzo_initialized, after which drawing can commence.","ref":"Uderzo.Bindings.html#uderzo_init/1","title":"Uderzo.Bindings.uderzo_init/1","type":"function"},{"doc":"Setup the start of a frame. This function combines several things that should happen at the start of every frame: get the window size, the cursor position, etcetera, then set the viewport and clear the framebuffer.When this function completes, it sends the mouse location and window dimensions back:{:uderzo_start_frame_result, mouse_x, mouse_y, win_width, win_height}It's recommended to wait for this message and then send the rest of the frame drawing commands.","ref":"Uderzo.Bindings.html#uderzo_start_frame/2","title":"Uderzo.Bindings.uderzo_start_frame/2","type":"function"},{"doc":"Generic rendering code. This will start a process that will render a frame at a regular rate in a window of the indicated size. Rendering the frame is done by calling a callback with the current window size and height and the current mouse pointer position.GenRenderer is using GenServer internally and is thus OTP compatible.Usually, if you want to use Uderzo, this is the module you want to build around. See also the examples and demos in the repository.The basic usage of GenRenderer is the same as GenServer: you use the module, supply a render_frame/5 callback and an optional init_renderer/1 callback. There are just more arguments than with GenServer ;-). Short skeleton:defmodule MyRenderer do use Uderzo.GenRenderer def start_link(...) do Uderzo.GenRenderer.start_link(__MODULE__, &quot;My Demo&quot;, 800, 600, 60, [], name: __MODULE__) end def init_renderer([]) do {:ok, %{some: :state}} end def render_frame(window_width, window_height, mouse_x, mouse_y, state) do ... Paint your frame here ... {:ok, state} endOne important difference with GenServer is that the init_renderer/1 callback isn't called during start time but rather as soon as Uderzo is initialized. This means that you can call functions to load fonts, etcetera, at initialization time.Note that once called, GenRenderer just goes off and does rendering. There's no requirement to interact with it further, although you can set the user state directly, forcing a redraw if desired.","ref":"Uderzo.GenRenderer.html","title":"Uderzo.GenRenderer","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Uderzo.GenRenderer.html#child_spec/1","title":"Uderzo.GenRenderer.child_spec/1","type":"function"},{"doc":"Get the user_state portion of %State{}. This is the data that gets passed into render.","ref":"Uderzo.GenRenderer.html#get_user_state/0","title":"Uderzo.GenRenderer.get_user_state/0","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Uderzo.GenRenderer.html#init/1","title":"Uderzo.GenRenderer.init/1","type":"function"},{"doc":"The (optional) init callback. It either returns :ok and the initial state, or an error which will cause the GenRenderer to bail out.","ref":"Uderzo.GenRenderer.html#c:init_renderer/1","title":"Uderzo.GenRenderer.init_renderer/1","type":"callback"},{"doc":"The rendering function. This is called fps times per second. It should try to complete quickly so that frames aren't skipped.","ref":"Uderzo.GenRenderer.html#c:render_frame/5","title":"Uderzo.GenRenderer.render_frame/5","type":"callback"},{"doc":"Set the user_state portion of %State{}. This is the data that gets passed into render. Calling this has the side effect of redrawing the screen.","ref":"Uderzo.GenRenderer.html#set_user_state/1","title":"Uderzo.GenRenderer.set_user_state/1","type":"function"},{"doc":"Start a GenRenderer with the indicated window height, width and title and the target FPS.The target_fps is a target, much rests on the speed of the rendering function for the real fps.The final argument, genserver_opts, is just passed on to GenServer.start_link/3.Returns GenServer.on_start.","ref":"Uderzo.GenRenderer.html#start_link/7","title":"Uderzo.GenRenderer.start_link/7","type":"function"},{"doc":"","ref":"Uderzo.GenRenderer.State.html","title":"Uderzo.GenRenderer.State","type":"module"},{"doc":"OverviewUderzo is a way of writing 2D user interfaces with minimum fuzz and maximum fun. It is based on Clixir for the interfacing with C.The basis for Uderzo is OpenGL (as the Embedded 2.0 profile) and NanoVG for the HTML5 Canvas like vector graphics. It currently supports the following platforms:Linux and MacOS, where GLFW will be used to open a window;RaspberryPi 3, which compiles against Broadcom's VideoCore library.The latter is the &quot;interesting&quot; target, as it will allow you to build a Nerves application which can write to either HDMI or a &quot;HAT&quot; style LCD/TFT display without needing extra stuff like Xorg or even Qt Embedded. However, nothing precludes you from writing games for Linux or MacOS for it.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"Currently, Uderzo is &quot;platform-complete&quot; in that the example app in its repository runs on the three target platforms. However, the library of functions is still pretty rudimentary. The expectation is that developing actual applications on top of it will drive a basic set of 2D functions that are directly accessible from Elixir.","ref":"overview.html#status","title":"Overview - Status","type":"extras"},{"doc":"The Uderzo repository, setup as a &quot;poncho&quot; style project, contains a simple example application that consists of three files:c_src/thermostat.cx. This is the Clixir header file that will be included on top of the generated C code. In this case, it just includes the Uderzo support header.lib/thermostat.ex. This is a regular Elixir file which uses Clixir to define C functions that draw stuff, mixed with Elixir functions to combine these C functions to higher-level primitives. As they sit in the same source file, switching functions from Elixir to C is trivial and transparent.lib/demo.ex. This is the top level driver - it initializes Uderzo and the thermostat demo, and then goes into a render loop that does the rendering and then instructs Uderzo to end the frame. This code is basically the boilerplate that every Uderzo application needs.At the moment, there is really not much more to it; input currently is not handled but very easy to slap on.","ref":"overview.html#example-code","title":"Overview - Example code","type":"extras"}]